package com.jasamedika.medifirst2000.controller;

import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.StokOpNameService;
import com.jasamedika.medifirst2000.vo.StokOpNameVO;
import com.jasamedika.medifirst2000.vo.StrukClosingVO;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import java.util.Map;

import static com.jasamedika.medifirst2000.constants.Constants.MessageInfo.ERROR_MESSAGE;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.slf4j.LoggerFactory.getLogger;
import static org.springframework.http.HttpStatus.*;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.GET;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

@RestController
@RequestMapping("/stok-op-name")
public class StokOpNameController extends LocaleController<StrukClosingVO> {

	private static final Logger LOGGER = getLogger(StokOpNameController.class);

	@Autowired
	private StokOpNameService stokOpNameService;

	@RequestMapping(value = "/list-stok-op-name")
	@ResponseBody
	public Map<String, Object> getStokGlobalByProduk(
			@RequestParam(value = "kelompokProdukId", required = false) Integer kelompokProdukId,
			@RequestParam(value = "produkId", required = false) Integer produkId,
			@RequestParam(value = "jenisProdukId", required = false) Integer jenisProdukId) {
		return stokOpNameService.getStokGlobalByProduk(kelompokProdukId, produkId, jenisProdukId);
	}

	@RequestMapping(value = "/save-stok-op-name", method = POST, produces = APPLICATION_JSON_VALUE, consumes = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> saveStokOpName(@Valid @RequestBody StokOpNameVO vo,
			HttpServletRequest request) {
		try {
			Map<String, Object> result = stokOpNameService.saveStokOpName(vo);
			if (null != result)
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when saveStokOpName", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when saveStokOpName", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/grid-stok-op-name")
	@ResponseBody
	public Map<String, Object> gridStokOpName(@RequestParam(value = "tanggalAwal", required = false) String tanggalAwal,
			@RequestParam(value = "tanggalAhir", required = false) String tanggalAhir) {
		return stokOpNameService.gridStokOpName(tanggalAwal, tanggalAhir);
	}

	@RequestMapping(value = "/get-stok-op-name-detail/", method = GET, produces = APPLICATION_JSON_VALUE)
	public Map<String, Object> kartuPengendliDetailList(@RequestParam(value = "tglClosing") String tglClosing) {
		return stokOpNameService.detailStokOpName(tglClosing);
	}

}
